<?php

declare(strict_types=1);

namespace Gls\GlsPoland\AdePlus\Type;

use JsonSerializable;
use Gls\GlsPoland\Soap\Client\Type\RequestInterface;

final class AdeProfileChange implements RequestInterface, JsonSerializable
{
    /**
     * @var string
     */
    private $session;

    /**
     * @var int
     */
    private $id;

    public function __construct(string $session, int $id)
    {
        $this->session = $session;
        $this->id = $id;
    }

    public function jsonSerialize(): array
    {
        return [
            'session' => $this->session,
            'id' => $this->id,
        ];
    }

    public function getSession(): string
    {
        return $this->session;
    }

    public function withSession(string $session): AdeProfileChange
    {
        $new = clone $this;
        $new->session = $session;

        return $new;
    }

    public function getId(): int
    {
        return $this->id;
    }

    public function withId(int $id): AdeProfileChange
    {
        $new = clone $this;
        $new->id = $id;

        return $new;
    }
}
